
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.y"

/*-------------------------------------------------------------------------
 * parser.y
 *
 *	The slonik command language grammar
 *
 *	Copyright (c) 2003-2009, PostgreSQL Global Development Group
 *	Author: Jan Wieck, Afilias USA INC.
 *
 *	
 *-------------------------------------------------------------------------
 */

#include "postgres.h"
#include "libpq-fe.h"
#include "slonik.h"


/*
 * Common option types
 */
typedef enum {
	O_ADD_ID,
	O_BACKUP_NODE,
	O_CLIENT,
	O_COMMENT,
	O_CONNINFO,
	O_CONNRETRY,
	O_EVENT_NODE,
	O_EXECUTE_ONLY_ON,
	O_FILENAME,
	O_FORWARD,
	O_FQNAME,
	O_ID,
	O_NEW_ORIGIN,
	O_NEW_SET,
	O_NODE_ID,
	O_OLD_ORIGIN,
	O_ORIGIN,
	O_PROVIDER,
	O_RECEIVER,
	O_SECONDS,
	O_SERVER,
	O_SER_KEY,
	O_SET_ID,
	O_SPOOLNODE,
	O_TAB_ID,
	O_TIMEOUT,
	O_TRIG_NAME,
	O_USE_KEY,
	O_WAIT_CONFIRMED,
	O_WAIT_ON,

	END_OF_OPTIONS = -1
} option_code;


/*
 * Common given option list
 */
typedef struct option_list {
	option_code	opt_code;
	int			lineno;
	int32		ival;
	char	   *str;

	struct option_list *next;
} option_list;


/*
 * Common per statement possible option strcture
 */
typedef struct statement_option {
	option_code	opt_code;
	int			lineno;
	int			ival;
	char	   *str;
} statement_option;
#define	STMT_OPTION_INT(_code,_dfl)		{_code, -1, _dfl, NULL}
#define	STMT_OPTION_STR(_code,_dfl)		{_code, -1, -1, _dfl}
#define	STMT_OPTION_YN(_code,_dfl)		{_code, -1, _dfl, NULL}
#define STMT_OPTION_END					{END_OF_OPTIONS, -1, -1, NULL}


/*
 * Global data
 */
char   *current_file = "<stdin>";
extern int yyleng;
#ifdef DEBUG
int yydebug=1;
#endif
/*
 * Local functions
 */
static int	assign_options(statement_option *so, option_list *ol);





/* Line 189 of yacc.c  */
#line 176 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     K_ADD = 258,
     K_ADMIN = 259,
     K_ALL = 260,
     K_BACKUP = 261,
     K_CLIENT = 262,
     K_CLUSTER = 263,
     K_CLUSTERNAME = 264,
     K_COMMENT = 265,
     K_CONFIRMED = 266,
     K_CONFIG = 267,
     K_CONNINFO = 268,
     K_CONNRETRY = 269,
     K_CREATE = 270,
     K_DROP = 271,
     K_ECHO = 272,
     K_ERROR = 273,
     K_EVENT = 274,
     K_EXECUTE = 275,
     K_EXIT = 276,
     K_FAILOVER = 277,
     K_FALSE = 278,
     K_FILENAME = 279,
     K_FOR = 280,
     K_FORWARD = 281,
     K_FULL = 282,
     K_FUNCTIONS = 283,
     K_ID = 284,
     K_INIT = 285,
     K_KEY = 286,
     K_LISTEN = 287,
     K_LOCK = 288,
     K_LOG = 289,
     K_MERGE = 290,
     K_MOVE = 291,
     K_NAME = 292,
     K_NEW = 293,
     K_NO = 294,
     K_NODE = 295,
     K_OFF = 296,
     K_OLD = 297,
     K_ON = 298,
     K_ONLY = 299,
     K_ORIGIN = 300,
     K_PATH = 301,
     K_PROVIDER = 302,
     K_QUALIFIED = 303,
     K_RECEIVER = 304,
     K_REPAIR = 305,
     K_RESTART = 306,
     K_SCRIPT = 307,
     K_SECONDS = 308,
     K_SEQUENCE = 309,
     K_SERIAL = 310,
     K_SERVER = 311,
     K_SET = 312,
     K_SPOOLNODE = 313,
     K_STORE = 314,
     K_SUBSCRIBE = 315,
     K_SUCCESS = 316,
     K_SWITCH = 317,
     K_TABLE = 318,
     K_TIMEOUT = 319,
     K_TRIGGER = 320,
     K_TRUE = 321,
     K_TRY = 322,
     K_UNINSTALL = 323,
     K_UNLOCK = 324,
     K_UNSUBSCRIBE = 325,
     K_UPDATE = 326,
     K_YES = 327,
     K_WAIT = 328,
     K_SYNC = 329,
     K_SLEEP = 330,
     T_IDENT = 331,
     T_LITERAL = 332,
     T_NUMBER = 333
   };
#endif
/* Tokens.  */
#define K_ADD 258
#define K_ADMIN 259
#define K_ALL 260
#define K_BACKUP 261
#define K_CLIENT 262
#define K_CLUSTER 263
#define K_CLUSTERNAME 264
#define K_COMMENT 265
#define K_CONFIRMED 266
#define K_CONFIG 267
#define K_CONNINFO 268
#define K_CONNRETRY 269
#define K_CREATE 270
#define K_DROP 271
#define K_ECHO 272
#define K_ERROR 273
#define K_EVENT 274
#define K_EXECUTE 275
#define K_EXIT 276
#define K_FAILOVER 277
#define K_FALSE 278
#define K_FILENAME 279
#define K_FOR 280
#define K_FORWARD 281
#define K_FULL 282
#define K_FUNCTIONS 283
#define K_ID 284
#define K_INIT 285
#define K_KEY 286
#define K_LISTEN 287
#define K_LOCK 288
#define K_LOG 289
#define K_MERGE 290
#define K_MOVE 291
#define K_NAME 292
#define K_NEW 293
#define K_NO 294
#define K_NODE 295
#define K_OFF 296
#define K_OLD 297
#define K_ON 298
#define K_ONLY 299
#define K_ORIGIN 300
#define K_PATH 301
#define K_PROVIDER 302
#define K_QUALIFIED 303
#define K_RECEIVER 304
#define K_REPAIR 305
#define K_RESTART 306
#define K_SCRIPT 307
#define K_SECONDS 308
#define K_SEQUENCE 309
#define K_SERIAL 310
#define K_SERVER 311
#define K_SET 312
#define K_SPOOLNODE 313
#define K_STORE 314
#define K_SUBSCRIBE 315
#define K_SUCCESS 316
#define K_SWITCH 317
#define K_TABLE 318
#define K_TIMEOUT 319
#define K_TRIGGER 320
#define K_TRUE 321
#define K_TRY 322
#define K_UNINSTALL 323
#define K_UNLOCK 324
#define K_UNSUBSCRIBE 325
#define K_UPDATE 326
#define K_YES 327
#define K_WAIT 328
#define K_SYNC 329
#define K_SLEEP 330
#define T_IDENT 331
#define T_LITERAL 332
#define T_NUMBER 333




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 106 "parser.y"

	int32		ival;
	char		*str;
	option_list	*opt_list;
	SlonikAdmInfo	*adm_info;
	SlonikStmt	*statement;



/* Line 214 of yacc.c  */
#line 378 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 390 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   336

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  87
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  62
/* YYNRULES -- Number of rules.  */
#define YYNRULES  145
/* YYNRULES -- Number of states.  */
#define YYNSTATES  315

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      84,    85,     2,     2,    86,    83,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    80,
       2,    79,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,    82,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,    14,    16,    19,    28,    30,    33,
      35,    37,    44,    52,    60,    67,    73,    79,    85,    87,
      90,    92,    94,    96,    98,   100,   102,   104,   106,   108,
     110,   112,   114,   116,   118,   120,   122,   124,   126,   128,
     130,   132,   134,   136,   138,   140,   142,   144,   146,   148,
     150,   152,   154,   156,   158,   161,   163,   165,   170,   175,
     181,   183,   186,   189,   194,   199,   204,   208,   213,   218,
     223,   228,   233,   238,   243,   248,   254,   260,   266,   272,
     278,   284,   290,   295,   300,   305,   310,   315,   320,   325,
     330,   335,   340,   346,   351,   355,   359,   361,   366,   368,
     372,   376,   381,   386,   390,   394,   398,   403,   408,   413,
     417,   421,   425,   429,   433,   438,   443,   448,   453,   458,
     464,   468,   472,   476,   480,   484,   488,   492,   497,   501,
     507,   511,   515,   517,   519,   521,   523,   525,   527,   529,
     531,   533,   535,   537,   539,   541
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      88,     0,    -1,    89,    90,    92,    -1,   148,     8,    37,
      79,   146,    80,    -1,    91,    -1,    91,    90,    -1,   148,
      40,   145,     4,    13,    79,   147,    80,    -1,    93,    -1,
      93,    92,    -1,    94,    -1,    98,    -1,   148,    67,    81,
      97,    82,    95,    -1,   148,    67,    81,    97,    82,    96,
      95,    -1,   148,    67,    81,    97,    82,    95,    96,    -1,
     148,    67,    81,    97,    82,    96,    -1,   148,    67,    81,
      97,    82,    -1,    43,    18,    81,    92,    82,    -1,    43,
      61,    81,    92,    82,    -1,    98,    -1,    98,    97,    -1,
      99,    -1,   100,    -1,   101,    -1,   104,    -1,   105,    -1,
     106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,
     116,    -1,   117,    -1,   118,    -1,   119,    -1,   120,    -1,
     121,    -1,   122,    -1,   123,    -1,   124,    -1,   125,    -1,
     126,    -1,   127,    -1,   128,    -1,   129,    -1,   130,    -1,
     131,    -1,   132,    -1,   133,    -1,   134,    -1,   103,    80,
      -1,   135,    -1,   136,    -1,   148,    17,   147,    80,    -1,
     148,    21,   102,    80,    -1,   148,    51,    40,   145,    80,
      -1,    78,    -1,    83,   102,    -1,   148,     1,    -1,   148,
      30,     8,   137,    -1,   148,    59,    40,   137,    -1,   148,
      16,    40,   137,    -1,   148,    22,   137,    -1,   148,    68,
      40,   137,    -1,   148,    59,    46,   137,    -1,   148,    16,
      46,   137,    -1,   148,    59,    32,   137,    -1,   148,    16,
      32,   137,    -1,   148,    15,    57,   137,    -1,   148,    16,
      57,   137,    -1,   148,    35,    57,   137,    -1,   148,    63,
       3,    31,   137,    -1,   148,    57,     3,    63,   137,    -1,
     148,    57,     3,    54,   137,    -1,   148,    57,    16,    63,
     137,    -1,   148,    57,    16,    54,   137,    -1,   148,    57,
      36,    63,   137,    -1,   148,    57,    36,    54,   137,    -1,
     148,    59,    65,   137,    -1,   148,    16,    65,   137,    -1,
     148,    60,    57,   137,    -1,   148,    70,    57,   137,    -1,
     148,    33,    57,   137,    -1,   148,    69,    57,   137,    -1,
     148,    36,    57,   137,    -1,   148,    20,    52,   137,    -1,
     148,    71,    28,   137,    -1,   148,    50,    12,   137,    -1,
     148,    73,    25,    19,   137,    -1,   148,    62,    34,   137,
      -1,   148,    74,   137,    -1,   148,    75,   137,    -1,    80,
      -1,    84,   138,    85,    80,    -1,   139,    -1,   139,    86,
     138,    -1,    29,    79,   140,    -1,     6,    40,    79,   140,
      -1,    19,    40,    79,   140,    -1,    56,    79,   140,    -1,
       7,    79,   140,    -1,    45,    79,   140,    -1,    42,    45,
      79,   140,    -1,    38,    45,    79,   140,    -1,    38,    57,
      79,   140,    -1,    49,    79,   140,    -1,    47,    79,   140,
      -1,    14,    79,   140,    -1,    10,    79,   141,    -1,    13,
      79,   141,    -1,    57,    29,    79,   140,    -1,     3,    29,
      79,   140,    -1,    40,    29,    79,   140,    -1,    63,    29,
      79,   140,    -1,    65,    37,    79,   141,    -1,    27,    48,
      37,    79,   141,    -1,    31,    79,   141,    -1,    31,    79,
      55,    -1,    26,    79,   142,    -1,    24,    79,   141,    -1,
      45,    79,     5,    -1,    11,    79,   140,    -1,    11,    79,
       5,    -1,    73,    43,    79,   140,    -1,    64,    79,   140,
      -1,    20,    44,    43,    79,   140,    -1,    58,    79,   142,
      -1,    53,    79,   140,    -1,   145,    -1,   147,    -1,   143,
      -1,   144,    -1,    72,    -1,    43,    -1,    66,    -1,    39,
      -1,    41,    -1,    23,    -1,    78,    -1,    76,    -1,    77,
      -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   264,   264,   279,   285,   287,   291,   309,   311,   315,
     317,   321,   338,   356,   374,   391,   408,   411,   415,   417,
     421,   423,   425,   427,   429,   431,   433,   435,   437,   439,
     441,   443,   445,   447,   449,   451,   453,   455,   457,   459,
     461,   463,   465,   467,   469,   471,   473,   475,   477,   479,
     481,   483,   485,   487,   489,   492,   494,   498,   515,   532,
     549,   551,   555,   570,   598,   630,   658,   686,   712,   744,
     774,   804,   834,   864,   892,   922,   950,   988,  1022,  1048,
    1076,  1104,  1134,  1164,  1194,  1226,  1254,  1282,  1310,  1340,
    1373,  1398,  1429,  1461,  1487,  1513,  1539,  1541,  1545,  1547,
    1551,  1556,  1561,  1566,  1571,  1576,  1581,  1586,  1591,  1596,
    1601,  1606,  1611,  1616,  1621,  1626,  1631,  1636,  1641,  1646,
    1651,  1656,  1669,  1674,  1679,  1692,  1697,  1710,  1715,  1720,
    1725,  1730,  1737,  1751,  1765,  1777,  1791,  1792,  1793,  1796,
    1797,  1798,  1801,  1807,  1819,  1832
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_ADD", "K_ADMIN", "K_ALL", "K_BACKUP",
  "K_CLIENT", "K_CLUSTER", "K_CLUSTERNAME", "K_COMMENT", "K_CONFIRMED",
  "K_CONFIG", "K_CONNINFO", "K_CONNRETRY", "K_CREATE", "K_DROP", "K_ECHO",
  "K_ERROR", "K_EVENT", "K_EXECUTE", "K_EXIT", "K_FAILOVER", "K_FALSE",
  "K_FILENAME", "K_FOR", "K_FORWARD", "K_FULL", "K_FUNCTIONS", "K_ID",
  "K_INIT", "K_KEY", "K_LISTEN", "K_LOCK", "K_LOG", "K_MERGE", "K_MOVE",
  "K_NAME", "K_NEW", "K_NO", "K_NODE", "K_OFF", "K_OLD", "K_ON", "K_ONLY",
  "K_ORIGIN", "K_PATH", "K_PROVIDER", "K_QUALIFIED", "K_RECEIVER",
  "K_REPAIR", "K_RESTART", "K_SCRIPT", "K_SECONDS", "K_SEQUENCE",
  "K_SERIAL", "K_SERVER", "K_SET", "K_SPOOLNODE", "K_STORE", "K_SUBSCRIBE",
  "K_SUCCESS", "K_SWITCH", "K_TABLE", "K_TIMEOUT", "K_TRIGGER", "K_TRUE",
  "K_TRY", "K_UNINSTALL", "K_UNLOCK", "K_UNSUBSCRIBE", "K_UPDATE", "K_YES",
  "K_WAIT", "K_SYNC", "K_SLEEP", "T_IDENT", "T_LITERAL", "T_NUMBER", "'='",
  "';'", "'{'", "'}'", "'-'", "'('", "')'", "','", "$accept", "script",
  "hdr_clustername", "hdr_admconninfos", "hdr_admconninfo", "stmts",
  "stmt", "stmt_try", "try_on_error", "try_on_success", "try_stmts",
  "try_stmt", "stmt_echo", "stmt_exit", "stmt_restart_node", "exit_code",
  "stmt_error", "stmt_init_cluster", "stmt_store_node", "stmt_drop_node",
  "stmt_failed_node", "stmt_uninstall_node", "stmt_store_path",
  "stmt_drop_path", "stmt_store_listen", "stmt_drop_listen",
  "stmt_create_set", "stmt_drop_set", "stmt_merge_set",
  "stmt_table_add_key", "stmt_set_add_table", "stmt_set_add_sequence",
  "stmt_set_drop_table", "stmt_set_drop_sequence", "stmt_set_move_table",
  "stmt_set_move_sequence", "stmt_store_trigger", "stmt_drop_trigger",
  "stmt_subscribe_set", "stmt_unsubscribe_set", "stmt_lock_set",
  "stmt_unlock_set", "stmt_move_set", "stmt_ddl_script",
  "stmt_update_functions", "stmt_repair_config", "stmt_wait_event",
  "stmt_switch_log", "stmt_sync", "stmt_sleep", "option_list",
  "option_list_items", "option_list_item", "option_item_id",
  "option_item_literal", "option_item_yn", "option_item_yn_yes",
  "option_item_yn_no", "id", "ident", "literal", "lno", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,    61,
      59,   123,   125,    45,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    87,    88,    89,    90,    90,    91,    92,    92,    93,
      93,    94,    94,    94,    94,    94,    95,    96,    97,    97,
      98,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    98,    98,    98,    98,    98,    99,   100,   101,
     102,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   137,   138,   138,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   140,   141,   142,   142,   143,   143,   143,   144,
     144,   144,   145,   146,   147,   148
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     6,     1,     2,     8,     1,     2,     1,
       1,     6,     7,     7,     6,     5,     5,     5,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     4,     4,     5,
       1,     2,     2,     4,     4,     4,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     5,     5,     5,     5,
       5,     5,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     5,     4,     3,     3,     1,     4,     1,     3,
       3,     4,     4,     3,     3,     3,     4,     4,     4,     3,
       3,     3,     3,     3,     4,     4,     4,     4,     4,     5,
       3,     3,     3,     3,     3,     3,     3,     4,     3,     5,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
     145,     0,   145,     0,     1,   145,     4,     0,     0,     2,
     145,     9,    10,    20,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    55,    56,
       0,     5,     0,     0,     8,    54,    62,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   142,     0,     0,     0,     0,     0,     0,     0,
       0,   144,     0,     0,    60,     0,     0,    96,     0,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   145,     0,     0,     0,
       0,     0,    94,    95,     0,   143,     0,    72,    71,    65,
      69,    73,    83,    57,    89,    61,    58,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98,    63,    86,    74,
      88,    91,     0,     0,     0,     0,     0,     0,     0,    70,
      64,    68,    82,    84,    93,     0,     0,   145,     0,    67,
      87,    85,    90,     0,     0,     3,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    59,    77,    76,
      79,    78,    81,    80,    75,    15,    19,    92,     0,     0,
       0,   104,   132,   112,   133,   126,   125,   113,   111,     0,
       0,   123,   141,   139,   140,   137,   138,   136,   122,   134,
     135,     0,   100,   121,   120,     0,     0,     0,     0,   124,
     105,   110,   109,   131,   103,     0,   130,     0,   128,     0,
       0,    97,    99,     0,    11,    14,     0,   115,   101,   102,
       0,     0,   107,   108,   116,   106,   114,   117,   118,   127,
       0,     0,     0,    13,     0,    12,     6,   129,   119,   145,
     145,     0,     0,    16,    17
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     5,     6,     9,    10,    11,   284,   285,
     186,    12,    13,    14,    15,    96,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      99,   165,   166,   241,   243,   258,   259,   260,   242,   126,
     244,    50
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -186
static const yytype_int16 yypact[] =
{
    -186,    32,  -186,    42,  -186,  -186,     0,    18,    30,  -186,
       8,  -186,  -186,  -186,  -186,  -186,    -9,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
     123,  -186,     2,    17,  -186,  -186,  -186,    22,    19,     6,
      29,    -8,   -27,    79,    40,    47,    51,    95,    69,    89,
       9,    58,    85,   117,    46,    88,    72,    73,   103,   107,
     -27,   -27,  -186,   129,    59,   -27,   -27,   -27,   -27,   -27,
     -27,  -186,    54,   -27,  -186,    -8,    57,  -186,   263,  -186,
     -27,   -27,   -27,   -27,   -27,     2,   -32,    -7,    15,   -27,
     -27,   -27,   -27,   -27,   -27,   110,  -186,   -27,   -27,   -27,
     -27,   127,  -186,  -186,   134,  -186,    62,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,   119,   109,    71,
      75,    76,    78,    81,   111,   108,    82,    83,   115,    86,
      87,   -24,   135,   122,    90,    91,    92,    93,    96,   139,
      97,   148,    99,   142,   141,   104,   113,  -186,  -186,  -186,
    -186,  -186,   120,   -27,   -27,   -27,   -27,   -27,   -27,  -186,
    -186,  -186,  -186,  -186,  -186,   -27,   128,   130,   186,  -186,
    -186,  -186,  -186,   -27,   116,  -186,   125,   126,     2,     6,
      -1,     6,     2,   132,   166,     6,    50,   176,     2,   -25,
     136,   138,   144,   145,     4,     2,     2,     2,     2,   146,
      50,   147,     2,   149,   150,   140,   263,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,   171,  -186,  -186,     6,     2,
       2,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,     2,
     151,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,   152,  -186,  -186,  -186,     2,     2,     2,     2,  -186,
    -186,  -186,  -186,  -186,  -186,     2,  -186,     2,  -186,     6,
       2,  -186,  -186,     5,   175,   184,   153,  -186,  -186,  -186,
       2,     6,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
     154,   157,   173,  -186,   214,  -186,  -186,  -186,  -186,  -186,
    -186,   158,   159,  -186,  -186
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -186,  -186,  -186,   233,  -186,   -10,  -186,  -186,   -43,   -40,
      60,   -99,  -186,  -186,  -186,   155,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
    -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,  -186,
     -75,    25,  -186,  -154,  -185,    33,  -186,  -186,   -33,  -186,
     -57,     1
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -146
static const yytype_int16 yytable[] =
{
      54,     3,    92,     7,   245,   122,   123,     7,    -7,   269,
     127,   128,   129,   130,   131,   132,   247,   187,   134,    83,
     251,   210,   173,   300,   264,   167,   168,   169,   170,   171,
     263,   174,     4,   211,   179,   180,   181,   182,   183,   184,
    -145,   109,   189,   190,   191,   192,   246,   175,   248,   110,
       8,    86,    91,    97,   262,   111,   176,    98,    52,    87,
     270,   271,   272,   273,   274,    88,   301,    53,   278,   177,
      94,    55,   172,   252,   112,    95,    89,    82,   178,    85,
      82,    93,    82,    91,    90,   287,   288,   100,   187,   253,
      -7,   254,   106,   255,   298,   289,    84,   101,   228,   229,
     230,   231,   232,   233,   102,   107,   308,   104,   103,   105,
     234,   292,   293,   294,   295,   113,   256,   188,   237,   114,
     115,   296,   257,   297,    56,   108,   299,   116,   117,   118,
     119,   120,   121,   124,   133,   125,   307,   136,    57,    58,
      59,   185,   195,    60,    61,    62,   193,   194,   196,   197,
     198,   203,   204,    63,   199,   200,    64,   201,    65,    66,
     202,   205,   206,   207,   212,   208,   209,   213,   219,   214,
     215,   216,   217,    67,    68,   218,   220,   221,   222,   223,
      69,   286,    70,    71,   224,    72,    73,    56,   188,   225,
      74,    75,    76,    77,    78,   238,    79,    80,    81,   226,
     227,    57,    58,    59,   239,   240,    60,    61,    62,   250,
     235,   249,   -18,   261,   283,   265,    63,   266,   302,    64,
     281,    65,    66,   267,   268,   275,   277,   304,   279,   280,
     290,   291,   300,   306,   301,   309,    67,    68,   310,    51,
     313,   314,   305,    69,   303,    70,    71,   236,    72,    73,
     135,   282,     0,   276,    75,    76,    77,    78,     0,    79,
      80,    81,     0,     0,     0,     0,   137,     0,     0,   138,
     139,     0,     0,   140,   141,     0,   142,   143,     0,     0,
       0,     0,   144,   145,     0,     0,     0,   146,     0,   147,
     148,     0,   149,     0,   150,     0,     0,     0,     0,   311,
     312,   151,     0,   152,     0,   153,     0,     0,   154,     0,
     155,     0,   156,     0,     0,     0,   157,     0,     0,   158,
     159,   160,     0,     0,     0,     0,   161,   162,   163,     0,
       0,     0,     0,     0,     0,     0,   164
};

static const yytype_int16 yycheck[] =
{
      10,     0,    59,     2,     5,    80,    81,     6,     0,     5,
      85,    86,    87,    88,    89,    90,   201,   116,    93,    52,
     205,    45,    54,    18,   209,   100,   101,   102,   103,   104,
      55,    63,     0,    57,   109,   110,   111,   112,   113,   114,
      40,    32,   117,   118,   119,   120,   200,    54,   202,    40,
       8,    32,    77,    80,   208,    46,    63,    84,    40,    40,
     214,   215,   216,   217,   218,    46,    61,    37,   222,    54,
      78,    80,   105,    23,    65,    83,    57,    78,    63,    57,
      78,    52,    78,    77,    65,   239,   240,     8,   187,    39,
      82,    41,     3,    43,   279,   249,    79,    57,   173,   174,
     175,   176,   177,   178,    57,    16,   291,    12,    57,    40,
     185,   265,   266,   267,   268,    57,    66,   116,   193,    34,
       3,   275,    72,   277,     1,    36,   280,    81,    40,    57,
      57,    28,    25,     4,    80,    76,   290,    80,    15,    16,
      17,    31,    80,    20,    21,    22,    19,    13,    29,    40,
      79,    40,    44,    30,    79,    79,    33,    79,    35,    36,
      79,    79,    79,    48,    29,    79,    79,    45,    29,    79,
      79,    79,    79,    50,    51,    79,    79,    29,    79,    37,
      57,   238,    59,    60,    43,    62,    63,     1,   187,    85,
      67,    68,    69,    70,    71,    79,    73,    74,    75,    86,
      80,    15,    16,    17,    79,    79,    20,    21,    22,    43,
      82,    79,    82,    37,    43,    79,    30,    79,    43,    33,
      80,    35,    36,    79,    79,    79,    79,    43,    79,    79,
      79,    79,    18,    80,    61,    81,    50,    51,    81,     6,
      82,    82,   285,    57,   284,    59,    60,   187,    62,    63,
      95,   226,    -1,   220,    68,    69,    70,    71,    -1,    73,
      74,    75,    -1,    -1,    -1,    -1,     3,    -1,    -1,     6,
       7,    -1,    -1,    10,    11,    -1,    13,    14,    -1,    -1,
      -1,    -1,    19,    20,    -1,    -1,    -1,    24,    -1,    26,
      27,    -1,    29,    -1,    31,    -1,    -1,    -1,    -1,   309,
     310,    38,    -1,    40,    -1,    42,    -1,    -1,    45,    -1,
      47,    -1,    49,    -1,    -1,    -1,    53,    -1,    -1,    56,
      57,    58,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    88,    89,   148,     0,    90,    91,   148,     8,    92,
      93,    94,    98,    99,   100,   101,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     148,    90,    40,    37,    92,    80,     1,    15,    16,    17,
      20,    21,    22,    30,    33,    35,    36,    50,    51,    57,
      59,    60,    62,    63,    67,    68,    69,    70,    71,    73,
      74,    75,    78,   145,    79,    57,    32,    40,    46,    57,
      65,    77,   147,    52,    78,    83,   102,    80,    84,   137,
       8,    57,    57,    57,    12,    40,     3,    16,    36,    32,
      40,    46,    65,    57,    34,     3,    81,    40,    57,    57,
      28,    25,   137,   137,     4,    76,   146,   137,   137,   137,
     137,   137,   137,    80,   137,   102,    80,     3,     6,     7,
      10,    11,    13,    14,    19,    20,    24,    26,    27,    29,
      31,    38,    40,    42,    45,    47,    49,    53,    56,    57,
      58,    63,    64,    65,    73,   138,   139,   137,   137,   137,
     137,   137,   145,    54,    63,    54,    63,    54,    63,   137,
     137,   137,   137,   137,   137,    31,    97,    98,   148,   137,
     137,   137,   137,    19,    13,    80,    29,    40,    79,    79,
      79,    79,    79,    40,    44,    79,    79,    48,    79,    79,
      45,    57,    29,    45,    79,    79,    79,    79,    79,    29,
      79,    29,    79,    37,    43,    85,    86,    80,   137,   137,
     137,   137,   137,   137,   137,    82,    97,   137,    79,    79,
      79,   140,   145,   141,   147,     5,   140,   141,   140,    79,
      43,   141,    23,    39,    41,    43,    66,    72,   142,   143,
     144,    37,   140,    55,   141,    79,    79,    79,    79,     5,
     140,   140,   140,   140,   140,    79,   142,    79,   140,    79,
      79,    80,   138,    43,    95,    96,   147,   140,   140,   140,
      79,    79,   140,   140,   140,   140,   140,   140,   141,   140,
      18,    61,    43,    96,    43,    95,    80,   140,   141,    81,
      81,    92,    92,    82,    82
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 267 "parser.y"
    {
						parser_script = (SlonikScript *)
								malloc(sizeof(SlonikScript));
						memset(parser_script, 0, sizeof(SlonikScript));

						parser_script->clustername		= (yyvsp[(1) - (3)].str);
						parser_script->filename			= current_file;
						parser_script->adminfo_list		= (yyvsp[(2) - (3)].adm_info);
						parser_script->script_stmts		= (yyvsp[(3) - (3)].statement);
					}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 280 "parser.y"
    {
						(yyval.str) = (yyvsp[(5) - (6)].str);
					}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 286 "parser.y"
    { (yyval.adm_info) = (yyvsp[(1) - (1)].adm_info); }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 288 "parser.y"
    { (yyvsp[(1) - (2)].adm_info)->next = (yyvsp[(2) - (2)].adm_info); (yyval.adm_info) = (yyvsp[(1) - (2)].adm_info); }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 292 "parser.y"
    {
						SlonikAdmInfo	   *new;

						new = (SlonikAdmInfo *)
								malloc(sizeof(SlonikAdmInfo));
						memset(new, 0, sizeof(SlonikAdmInfo));

						new->no_id			= (yyvsp[(3) - (8)].ival);
						new->stmt_filename	= current_file;
						new->stmt_lno		= (yyvsp[(1) - (8)].ival);
						new->conninfo		= (yyvsp[(7) - (8)].str);
						new->last_event		= -1;

						(yyval.adm_info) = new;
					}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 310 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 312 "parser.y"
    { (yyvsp[(1) - (2)].statement)->next = (yyvsp[(2) - (2)].statement); (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 316 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 318 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 323 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (6)].ival);

						new->try_block = (yyvsp[(4) - (6)].statement);
						new->error_block = (yyvsp[(6) - (6)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 340 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (7)].ival);

						new->try_block = (yyvsp[(4) - (7)].statement);
						new->success_block = (yyvsp[(6) - (7)].statement);
						new->error_block = (yyvsp[(7) - (7)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 358 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (7)].ival);

						new->try_block = (yyvsp[(4) - (7)].statement);
						new->success_block = (yyvsp[(7) - (7)].statement);
						new->error_block = (yyvsp[(6) - (7)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 376 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (6)].ival);

						new->try_block = (yyvsp[(4) - (6)].statement);
						new->success_block = (yyvsp[(6) - (6)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 392 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						new->try_block = (yyvsp[(4) - (5)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 409 "parser.y"
    { (yyval.statement) = (yyvsp[(4) - (5)].statement); }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 412 "parser.y"
    { (yyval.statement) = (yyvsp[(4) - (5)].statement); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 416 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 418 "parser.y"
    { (yyvsp[(1) - (2)].statement)->next = (yyvsp[(2) - (2)].statement); (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 422 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 424 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 426 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 428 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 430 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 432 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 434 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 436 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 438 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 440 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 442 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 444 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 446 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 448 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 450 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 452 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 454 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 456 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 458 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 460 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 462 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 464 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 466 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 468 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 470 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 472 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 474 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 476 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 478 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 480 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 482 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 484 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 486 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 488 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 490 "parser.y"
    { yyerrok;
						  (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 493 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 495 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 499 "parser.y"
    {
						SlonikStmt_echo *new;

						new = (SlonikStmt_echo *)
								malloc(sizeof(SlonikStmt_echo));
						memset(new, 0, sizeof(SlonikStmt_echo));
						new->hdr.stmt_type		= STMT_ECHO;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						new->str = (yyvsp[(3) - (4)].str);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 516 "parser.y"
    {
						SlonikStmt_exit *new;

						new = (SlonikStmt_exit *)
								malloc(sizeof(SlonikStmt_exit));
						memset(new, 0, sizeof(SlonikStmt_exit));
						new->hdr.stmt_type		= STMT_EXIT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						new->exitcode = (yyvsp[(3) - (4)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 533 "parser.y"
    {
						SlonikStmt_restart_node *new;

						new = (SlonikStmt_restart_node *)
								malloc(sizeof(SlonikStmt_restart_node));
						memset(new, 0, sizeof(SlonikStmt_restart_node));
						new->hdr.stmt_type		= STMT_RESTART_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						new->no_id = (yyvsp[(4) - (5)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 550 "parser.y"
    { (yyval.ival) = strtol(yytext, NULL, 10); }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 552 "parser.y"
    { (yyval.ival) = -(yyvsp[(2) - (2)].ival); }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 556 "parser.y"
    {
						SlonikStmt *new;

						new = (SlonikStmt *)
								malloc(sizeof(SlonikStmt));
						memset(new, 0, sizeof(SlonikStmt));
						new->stmt_type		= STMT_ERROR;
						new->stmt_filename	= current_file;
						new->stmt_lno		= (yyvsp[(1) - (2)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 571 "parser.y"
    {
						SlonikStmt_init_cluster *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, 1 ),
							STMT_OPTION_STR( O_COMMENT, "Primary Node 1" ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_init_cluster *)
								malloc(sizeof(SlonikStmt_init_cluster));
						memset(new, 0, sizeof(SlonikStmt_init_cluster));
						new->hdr.stmt_type		= STMT_INIT_CLUSTER;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_comment		= opt[1].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 599 "parser.y"
    {
						SlonikStmt_store_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_YN( O_SPOOLNODE, 0 ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_node *)
								malloc(sizeof(SlonikStmt_store_node));
						memset(new, 0, sizeof(SlonikStmt_store_node));
						new->hdr.stmt_type		= STMT_STORE_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_comment		= opt[1].str;
							new->no_spool		= opt[2].ival;
							new->ev_origin		= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 631 "parser.y"
    {
						SlonikStmt_drop_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_node *)
								malloc(sizeof(SlonikStmt_drop_node));
						memset(new, 0, sizeof(SlonikStmt_drop_node));
						new->hdr.stmt_type		= STMT_DROP_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->ev_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 659 "parser.y"
    {
						SlonikStmt_failed_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_BACKUP_NODE, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_failed_node *)
								malloc(sizeof(SlonikStmt_failed_node));
						memset(new, 0, sizeof(SlonikStmt_failed_node));
						new->hdr.stmt_type		= STMT_FAILED_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->backup_node	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 687 "parser.y"
    {
						SlonikStmt_uninstall_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_uninstall_node *)
								malloc(sizeof(SlonikStmt_uninstall_node));
						memset(new, 0, sizeof(SlonikStmt_uninstall_node));
						new->hdr.stmt_type		= STMT_UNINSTALL_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 713 "parser.y"
    {
						SlonikStmt_store_path *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SERVER, -1 ),
							STMT_OPTION_INT( O_CLIENT, -1 ),
							STMT_OPTION_STR( O_CONNINFO, NULL ),
							STMT_OPTION_INT( O_CONNRETRY, 10 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_path *)
								malloc(sizeof(SlonikStmt_store_path));
						memset(new, 0, sizeof(SlonikStmt_store_path));
						new->hdr.stmt_type		= STMT_STORE_PATH;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->pa_server		= opt[0].ival;
							new->pa_client		= opt[1].ival;
							new->pa_conninfo	= opt[2].str;
							new->pa_connretry	= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 745 "parser.y"
    {
						SlonikStmt_drop_path *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SERVER, -1 ),
							STMT_OPTION_INT( O_CLIENT, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_path *)
								malloc(sizeof(SlonikStmt_drop_path));
						memset(new, 0, sizeof(SlonikStmt_drop_path));
						new->hdr.stmt_type		= STMT_DROP_PATH;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->pa_server		= opt[0].ival;
							new->pa_client		= opt[1].ival;
							new->ev_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 775 "parser.y"
    {
						SlonikStmt_store_listen *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_listen *)
								malloc(sizeof(SlonikStmt_store_listen));
						memset(new, 0, sizeof(SlonikStmt_store_listen));
						new->hdr.stmt_type		= STMT_STORE_LISTEN;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->li_origin		= opt[0].ival;
							new->li_receiver	= opt[1].ival;
							new->li_provider	= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 805 "parser.y"
    {
						SlonikStmt_drop_listen *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_listen *)
								malloc(sizeof(SlonikStmt_drop_listen));
						memset(new, 0, sizeof(SlonikStmt_drop_listen));
						new->hdr.stmt_type		= STMT_DROP_LISTEN;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->li_origin		= opt[0].ival;
							new->li_receiver	= opt[1].ival;
							new->li_provider	= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 835 "parser.y"
    {
						SlonikStmt_create_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_create_set *)
								malloc(sizeof(SlonikStmt_create_set));
						memset(new, 0, sizeof(SlonikStmt_create_set));
						new->hdr.stmt_type		= STMT_CREATE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->set_comment	= opt[2].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 865 "parser.y"
    {
						SlonikStmt_drop_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_set *)
								malloc(sizeof(SlonikStmt_drop_set));
						memset(new, 0, sizeof(SlonikStmt_drop_set));
						new->hdr.stmt_type		= STMT_DROP_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 893 "parser.y"
    {
						SlonikStmt_merge_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ADD_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_merge_set *)
								malloc(sizeof(SlonikStmt_merge_set));
						memset(new, 0, sizeof(SlonikStmt_merge_set));
						new->hdr.stmt_type		= STMT_MERGE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->add_id			= opt[1].ival;
							new->set_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 923 "parser.y"
    {
						SlonikStmt_table_add_key *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_NODE_ID, -1 ),
							STMT_OPTION_STR( O_FQNAME, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_table_add_key *)
								malloc(sizeof(SlonikStmt_table_add_key));
						memset(new, 0, sizeof(SlonikStmt_table_add_key));
						new->hdr.stmt_type		= STMT_TABLE_ADD_KEY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->tab_fqname		= opt[1].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 951 "parser.y"
    {
						SlonikStmt_set_add_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_FQNAME, NULL ),
							STMT_OPTION_STR( O_USE_KEY, NULL ),
							STMT_OPTION_INT( O_SER_KEY, 0 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_add_table *)
								malloc(sizeof(SlonikStmt_set_add_table));
						memset(new, 0, sizeof(SlonikStmt_set_add_table));
						new->hdr.stmt_type		= STMT_SET_ADD_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->tab_id			= opt[2].ival;
							new->tab_fqname		= opt[3].str;
							new->use_key		= opt[4].str;
							new->use_serial		= opt[5].ival;
							new->tab_comment	= opt[6].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 989 "parser.y"
    {
						SlonikStmt_set_add_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_FQNAME, NULL ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_add_sequence *)
								malloc(sizeof(SlonikStmt_set_add_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_add_sequence));
						new->hdr.stmt_type		= STMT_SET_ADD_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->seq_id			= opt[2].ival;
							new->seq_fqname		= opt[3].str;
							new->seq_comment	= opt[4].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1023 "parser.y"
    {
						SlonikStmt_set_drop_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};
						new = (SlonikStmt_set_drop_table *)
							malloc(sizeof(SlonikStmt_set_drop_table));
						memset(new, 0, sizeof(SlonikStmt_set_drop_table));
						new->hdr.stmt_type		= STMT_SET_DROP_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0) {
							new->set_origin		= opt[0].ival;
							new->tab_id			= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1049 "parser.y"
    {
						SlonikStmt_set_drop_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_drop_sequence *)
								malloc(sizeof(SlonikStmt_set_drop_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_drop_sequence));
						new->hdr.stmt_type		= STMT_SET_DROP_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_origin		= opt[0].ival;
							new->seq_id			= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1077 "parser.y"
    {
						SlonikStmt_set_move_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_NEW_SET, -1 ),
							STMT_OPTION_END
						};
						new = (SlonikStmt_set_move_table *)
							malloc(sizeof(SlonikStmt_set_move_table));
						memset(new, 0, sizeof(SlonikStmt_set_move_table));
						new->hdr.stmt_type		= STMT_SET_MOVE_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0) {
							new->set_origin		= opt[0].ival;
							new->tab_id			= opt[1].ival;
							new->new_set_id		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1105 "parser.y"
    {
						SlonikStmt_set_move_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_NEW_SET, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_move_sequence *)
								malloc(sizeof(SlonikStmt_set_move_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_move_sequence));
						new->hdr.stmt_type		= STMT_SET_MOVE_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_origin		= opt[0].ival;
							new->seq_id			= opt[1].ival;
							new->new_set_id		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1135 "parser.y"
    {
						SlonikStmt_store_trigger *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_TAB_ID, -1 ),
							STMT_OPTION_STR( O_TRIG_NAME, NULL ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_trigger *)
								malloc(sizeof(SlonikStmt_store_trigger));
						memset(new, 0, sizeof(SlonikStmt_store_trigger));
						new->hdr.stmt_type		= STMT_STORE_TRIGGER;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->trig_tabid		= opt[0].ival;
							new->trig_tgname	= opt[1].str;
							new->ev_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1165 "parser.y"
    {
						SlonikStmt_drop_trigger *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_TAB_ID, -1 ),
							STMT_OPTION_STR( O_TRIG_NAME, NULL ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_trigger *)
								malloc(sizeof(SlonikStmt_drop_trigger));
						memset(new, 0, sizeof(SlonikStmt_drop_trigger));
						new->hdr.stmt_type		= STMT_DROP_TRIGGER;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->trig_tabid		= opt[0].ival;
							new->trig_tgname	= opt[1].str;
							new->ev_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1195 "parser.y"
    {
						SlonikStmt_subscribe_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_YN( O_FORWARD, 0 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_subscribe_set *)
								malloc(sizeof(SlonikStmt_subscribe_set));
						memset(new, 0, sizeof(SlonikStmt_subscribe_set));
						new->hdr.stmt_type		= STMT_SUBSCRIBE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->sub_setid		= opt[0].ival;
							new->sub_provider	= opt[1].ival;
							new->sub_receiver	= opt[2].ival;
							new->sub_forward	= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1227 "parser.y"
    {
						SlonikStmt_unsubscribe_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_unsubscribe_set *)
								malloc(sizeof(SlonikStmt_unsubscribe_set));
						memset(new, 0, sizeof(SlonikStmt_unsubscribe_set));
						new->hdr.stmt_type		= STMT_UNSUBSCRIBE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->sub_setid		= opt[0].ival;
							new->sub_receiver	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1255 "parser.y"
    {
						SlonikStmt_lock_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_lock_set *)
								malloc(sizeof(SlonikStmt_lock_set));
						memset(new, 0, sizeof(SlonikStmt_lock_set));
						new->hdr.stmt_type		= STMT_LOCK_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1283 "parser.y"
    {
						SlonikStmt_unlock_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_unlock_set *)
								malloc(sizeof(SlonikStmt_unlock_set));
						memset(new, 0, sizeof(SlonikStmt_unlock_set));
						new->hdr.stmt_type		= STMT_UNLOCK_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1311 "parser.y"
    {
						SlonikStmt_move_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_OLD_ORIGIN, -1 ),
							STMT_OPTION_INT( O_NEW_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_move_set *)
								malloc(sizeof(SlonikStmt_move_set));
						memset(new, 0, sizeof(SlonikStmt_move_set));
						new->hdr.stmt_type		= STMT_MOVE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->old_origin		= opt[1].ival;
							new->new_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1341 "parser.y"
    {
						SlonikStmt_ddl_script *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_STR( O_FILENAME, NULL ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_INT( O_EXECUTE_ONLY_ON, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_ddl_script *)
								malloc(sizeof(SlonikStmt_ddl_script));
						memset(new, 0, sizeof(SlonikStmt_ddl_script));
						new->hdr.stmt_type		= STMT_DDL_SCRIPT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->ddl_setid		= opt[0].ival;
							new->ddl_fname		= opt[1].str;
							new->ev_origin		= opt[2].ival;
							new->only_on_node	= opt[3].ival;
							new->ddl_fd		= NULL;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1374 "parser.y"
    {
						SlonikStmt_update_functions *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, 1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_update_functions *)
								malloc(sizeof(SlonikStmt_update_functions));
						memset(new, 0, sizeof(SlonikStmt_update_functions));
						new->hdr.stmt_type		= STMT_UPDATE_FUNCTIONS;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1399 "parser.y"
    {
						SlonikStmt_repair_config *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, 1 ),
							STMT_OPTION_INT( O_EXECUTE_ONLY_ON, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_repair_config *)
							malloc(sizeof(SlonikStmt_repair_config));
						memset(new, 0, sizeof(SlonikStmt_repair_config));
                                                new->hdr.stmt_type              = STMT_REPAIR_CONFIG;
                                                new->hdr.stmt_filename  = current_file;
                                                new->hdr.stmt_lno               = (yyvsp[(1) - (4)].ival);

                                                if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id		= opt[0].ival;
							new->ev_origin		= opt[1].ival;
							new->only_on_node	= opt[2].ival;
						}
						else
						{
							parser_errors++;
						}
                                                (yyval.statement) = (SlonikStmt *)new;
                                        }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1430 "parser.y"
    {
						SlonikStmt_wait_event *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_WAIT_CONFIRMED, -1 ),
							STMT_OPTION_INT( O_WAIT_ON, 1 ),
							STMT_OPTION_INT( O_TIMEOUT, 600 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_wait_event *)
								malloc(sizeof(SlonikStmt_wait_event));
						memset(new, 0, sizeof(SlonikStmt_wait_event));
						new->hdr.stmt_type		= STMT_WAIT_EVENT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->wait_origin	= opt[0].ival;
							new->wait_confirmed	= opt[1].ival;
							new->wait_on		= opt[2].ival;
							new->wait_timeout	= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1462 "parser.y"
    {
						SlonikStmt_switch_log *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_switch_log *)
								malloc(sizeof(SlonikStmt_switch_log));
						memset(new, 0, sizeof(SlonikStmt_switch_log));
						new->hdr.stmt_type		= STMT_SWITCH_LOG;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1488 "parser.y"
    {
						SlonikStmt_sync *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_sync *)
								malloc(sizeof(SlonikStmt_sync));
						memset(new, 0, sizeof(SlonikStmt_sync));
						new->hdr.stmt_type		= STMT_SYNC;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1514 "parser.y"
    {
						SlonikStmt_sleep *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SECONDS, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_sleep *)
								malloc(sizeof(SlonikStmt_sleep));
						memset(new, 0, sizeof(SlonikStmt_sleep));
						new->hdr.stmt_type		= STMT_SLEEP;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->num_secs			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1540 "parser.y"
    { (yyval.opt_list) = NULL; }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1542 "parser.y"
    { (yyval.opt_list) = (yyvsp[(2) - (4)].opt_list); }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1546 "parser.y"
    { (yyval.opt_list) = (yyvsp[(1) - (1)].opt_list); }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1548 "parser.y"
    { (yyvsp[(1) - (3)].opt_list)->next = (yyvsp[(3) - (3)].opt_list); (yyval.opt_list) = (yyvsp[(1) - (3)].opt_list); }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1552 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_ID;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1557 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_BACKUP_NODE;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1562 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_EVENT_NODE;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1567 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_SERVER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1572 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CLIENT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1577 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_ORIGIN;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1582 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_OLD_ORIGIN;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1587 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NEW_ORIGIN;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1592 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NEW_SET;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1597 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_RECEIVER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1602 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_PROVIDER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1607 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CONNRETRY;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1612 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_COMMENT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1617 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CONNINFO;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1622 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_SET_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1627 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_ADD_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1632 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NODE_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1637 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_TAB_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1642 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_TRIG_NAME;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1647 "parser.y"
    {
						(yyvsp[(5) - (5)].opt_list)->opt_code	= O_FQNAME;
						(yyval.opt_list) = (yyvsp[(5) - (5)].opt_list);
					}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1652 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_USE_KEY;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1657 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->opt_code	= O_SER_KEY;
						new->ival	= 1;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1670 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_FORWARD;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1675 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_FILENAME;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1680 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->opt_code	= O_ORIGIN;
						new->ival	= -2;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1693 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_WAIT_CONFIRMED;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1698 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->opt_code	= O_WAIT_CONFIRMED;
						new->ival	= -2;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1711 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_WAIT_ON;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1716 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_TIMEOUT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1721 "parser.y"
    {
						(yyvsp[(5) - (5)].opt_list)->opt_code	= O_EXECUTE_ONLY_ON;
						(yyval.opt_list) = (yyvsp[(5) - (5)].opt_list);
					}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1726 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_SPOOLNODE;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1731 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_SECONDS;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1738 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= (yyvsp[(1) - (1)].ival);
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1752 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= -1;
						new->str	= (yyvsp[(1) - (1)].str);
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1766 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= 1;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1778 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= 0;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1802 "parser.y"
    {
						(yyval.ival) = strtol(yytext, NULL, 10);
					}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1808 "parser.y"
    {
						char   *ret;

						ret = malloc(yyleng + 1);
						memcpy(ret, yytext, yyleng);
						ret[yyleng] = '\0';

						(yyval.str) = ret;
					}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1820 "parser.y"
    {
						char   *ret;

						ret = malloc(yyleng + 1);
						memcpy(ret, yytext, yyleng);
						ret[yyleng] = '\0';

						(yyval.str) = ret;
					}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1832 "parser.y"
    { (yyval.ival) = yylineno; }
    break;



/* Line 1455 of yacc.c  */
#line 4022 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1835 "parser.y"



/* ----------
 * option_str
 *
 *	Returns a string representation of a common option type
 * ----------
 */
static char *
option_str(option_code opt_code)
{
	switch (opt_code)
	{
		case O_ADD_ID:			return "add id";
		case O_BACKUP_NODE:		return "backup node";
		case O_CLIENT:			return "client";
		case O_COMMENT:			return "comment";
		case O_CONNINFO:		return "conninfo";
		case O_CONNRETRY:		return "connretry";
		case O_EVENT_NODE:		return "event node";
		case O_EXECUTE_ONLY_ON:	return "execute only on";
		case O_FILENAME:		return "filename";
		case O_FORWARD:			return "forward";
		case O_FQNAME:			return "full qualified name";
		case O_ID:				return "id";
		case O_NEW_ORIGIN:		return "new origin";
		case O_NEW_SET:			return "new set";
		case O_NODE_ID:			return "node id";
		case O_OLD_ORIGIN:		return "old origin";
		case O_ORIGIN:			return "origin";
		case O_PROVIDER:		return "provider";
		case O_RECEIVER:		return "receiver";
    	case O_SECONDS:         return "seconds";
		case O_SERVER:			return "server";
		case O_SER_KEY:			return "key";
		case O_SET_ID:			return "set id";
		case O_SPOOLNODE:		return "spoolnode";
		case O_TAB_ID:			return "table id";
		case O_TIMEOUT:			return "timeout";
		case O_TRIG_NAME:		return "trigger name";
		case O_USE_KEY:			return "key";
		case O_WAIT_CONFIRMED:	return "confirmed";
		case O_WAIT_ON:			return "wait on";
		case END_OF_OPTIONS:	return "???";
	}
	return "???";
}

/* ----------
 * assign_options
 *
 *	Try to map the actually given options to the statements specific
 *	possible options.
 * ----------
 */
static int
assign_options(statement_option *so, option_list *ol)
{
	statement_option	   *s_opt;
	option_list			   *u_opt;
	int						errors = 0;

	for (u_opt = ol; u_opt; u_opt = u_opt->next)
	{
		for (s_opt = so; s_opt->opt_code >= 0; s_opt++)
		{
			if (s_opt->opt_code == u_opt->opt_code)
				break;
		}

		if (s_opt->opt_code < 0)
		{
			fprintf(stderr, "%s:%d: option %s not allowed here\n",
					current_file, u_opt->lineno,
					option_str(u_opt->opt_code));
			errors++;
			continue;
		}

		if (s_opt->lineno >= 0)
		{
			fprintf(stderr, "%s:%d: option %s already defined on line %d\n",
					current_file, u_opt->lineno,
					option_str(u_opt->opt_code), s_opt->lineno);
			errors++;
			continue;
		}

		s_opt->lineno	= u_opt->lineno;
		s_opt->ival		= u_opt->ival;
		s_opt->str		= u_opt->str;
	}

	return errors;
}


void
yyerror(const char *msg)
{
	fprintf(stderr, "%s:%d: ERROR: %s at or near %s\n", current_file,
				yylineno, msg, yytext);
	parser_errors++;
}


/*
 * Include the output of fles for the scanner here.
 */
#include "scan.c"



/*
 * Local Variables:
 *  tab-width: 4
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 */

